from cpl_core.database.context import DatabaseContextABC
from cpl_core.dependency_injection import ServiceProviderABC
from cpl_query.extension import List

from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.data_seeder_abc import DataSeederABC


class SeederService:

    def __init__(self, logger: DatabaseLogger, services: ServiceProviderABC, db: DatabaseContextABC):
        self._logger = logger
        self._services = services

        self._db = db

        self._seeder = List(type, DataSeederABC.__subclasses__())

    async def seed(self):
        self._logger.info(__name__, f"Seed data")
        for seeder in self._seeder:
            seeder_as_service: DataSeederABC = self._services.get_service(seeder)
            self._logger.debug(__name__, f"Starting seeder {seeder.__name__}")
            await seeder_as_service.seed()
            self._db.save_changes()
